#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;
 
typedef long long ll;
void gen_case(int n,int m,int S1,int S2){
    vector<int>input={n,m};
    println(input);
    vector<vector<int>>a(n,vector<int>(m));
    for(int i=0;i<n;i++){
        int x=rnd.next(0,100);
        for(int j=0;j<m;j++){
            a[i][j]=x;
        }
    }
    sort(a.begin(),a.end(),[&](vector<int>&a,vector<int>&b){
        return a[0]<b[0];
    });
    if(S1!=-1){
        swap(a[S1],a[S2]);
    }
    for(int i=0;i<n;i++){
        println(a[i]);
    }
}
 
int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n=opt<int>("n");
    int m=opt<int>("m");
    int S1=opt<int>("S1");
    int S2=opt<int>("S2");
    gen_case(n,m,S1,S2);
    return 0;
}
